' ----------------------------------------------------------------------------------
' Microsoft Developer & Platform Evangelism
' 
' Copyright (c) Microsoft Corporation. All rights reserved.
' 
' THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
' EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
' OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ----------------------------------------------------------------------------------
' The example companies, organizations, products, domain names,
' e-mail addresses, logos, people, places, and events depicted
' herein are fictitious.  No association with any real company,
' organization, product, domain name, email address, logo, person,
' places, or events is intended or should be inferred.
' ----------------------------------------------------------------------------------

Imports System.Activities
Imports System.ComponentModel
Imports HelloWorkflow.Activities.Designers

<Designer(GetType(PrePostSequenceDesigner))>
Public NotInheritable Class PrePostSequence
    Inherits NativeActivity

    Public Property Pre() As Activity
    Public Property Post() As Activity
    Public Property Activities() As List(Of Activity)

    Public Sub New()
        Activities = New List(Of Activity)()
    End Sub

    Protected Overrides Sub Execute(ByVal context As System.Activities.NativeActivityContext)
        ' Schedule the activities in order
        context.ScheduleActivity(Pre)
        For Each Activity In Activities
            context.ScheduleActivity(Activity)
        Next
        context.ScheduleActivity(Post)
    End Sub
End Class