' ----------------------------------------------------------------------------------
' Microsoft Developer & Platform Evangelism
' 
' Copyright (c) Microsoft Corporation. All rights reserved.
' 
' THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
' EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
' OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ----------------------------------------------------------------------------------
' The example companies, organizations, products, domain names,
' e-mail addresses, logos, people, places, and events depicted
' herein are fictitious.  No association with any real company,
' organization, product, domain name, email address, logo, person,
' places, or events is intended or should be inferred.
' ----------------------------------------------------------------------------------

Imports System.Activities.Presentation
Imports System.Activities.Statements
Imports System.Activities.Presentation.Toolbox
Imports System.Activities.Core.Presentation
Imports System.Activities.Presentation.Metadata
Imports System.ComponentModel
Imports HelloWorkflow.Activities
Imports HelloWorkflow.Activities.Designers

Class MainWindow
    Private workflowDesigner As WorkflowDesigner = New WorkflowDesigner()

    Public Sub New()
        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        RegisterMetadata()
        AddDesigner()
    End Sub

    Public Sub RegisterMetadata()
        Dim metaData As DesignerMetadata = New DesignerMetadata()
        metaData.Register()
        Dim builder As AttributeTableBuilder = New AttributeTableBuilder()
        MetadataStore.AddAttributeTable(builder.CreateTable())
    End Sub

    Private Function CreateToolboxControl() As ToolboxControl
        'Create the ToolBoxControl
        Dim ctrl As ToolboxControl = New ToolboxControl()

        'Create a collection of category items
        Dim category As ToolboxCategory = New ToolboxCategory("Hello Workflow")

        'Creating toolboxItems
        Dim tool0 As ToolboxItemWrapper = New ToolboxItemWrapper(
            "System.Activities.Statements.Assign",
            "System.Activities, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35",
            Nothing,
            "Assign")
        Dim tool1 As ToolboxItemWrapper = New ToolboxItemWrapper(
            "System.Activities.Statements.Sequence",
            "System.Activities, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35",
            Nothing,
            "Sequence")
        Dim tool2 As ToolboxItemWrapper = New ToolboxItemWrapper(
            "System.Activities.Statements.TryCatch",
            "System.Activities, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35",
            Nothing,
            "Try It") ' Can use a different name
        Dim tool3 As ToolboxItemWrapper = New ToolboxItemWrapper(
            "HelloWorkflow.Activities.PrePostSequence",
            "HelloWorkflow.Activities",
            Nothing,
            "PrePostSequence")

        'Adding the toolboxItems to the category.
        category.Add(tool0)
        category.Add(tool1)
        category.Add(tool2)
        category.Add(tool3)

        'Adding the category to the ToolBox control.
        ctrl.Categories.Add(category)
        Return ctrl
    End Function

    Private Sub AddDesigner()

        'Create an instance of WorkflowDesigner class
        workflowDesigner = New WorkflowDesigner()

        'Place the WorkflowDesigner in the middle column of the grid
        Grid.SetColumn(workflowDesigner.View, 1)

        ' Setup the Model Changed event handler
        AddHandler workflowDesigner.ModelChanged,
            Function(sender As Object, e As System.EventArgs)
                ' Flush the workflow when the model changes
                workflowDesigner.Flush()
                textXAML.Text = workflowDesigner.Text
                Return Nothing
            End Function

        'Load a new Sequence as default.
        workflowDesigner.Load(New Sequence())

        'Add the WorkflowDesigner to the grid
        grid1.Children.Add(workflowDesigner.View)

        ' Add the Property Inspector
        Grid.SetColumn(workflowDesigner.PropertyInspectorView, 2)
        grid1.Children.Add(workflowDesigner.PropertyInspectorView)

        ' Add the toolbox
        Dim tc As ToolboxControl = CreateToolboxControl()
        Grid.SetColumn(tc, 0)
        grid1.Children.Add(tc)
    End Sub

End Class